package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.List;

public class ExampleMain2 {

    public static void main(String[] args) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("example-unit");
        try {
            persistEntity(emf);
            runNativeQueries(emf);
            loadEntity(emf);
        } finally {
            emf.close();
        }
    }

    private static void persistEntity(EntityManagerFactory emf) {
        System.out.println("-- Persisting entities --");
        EntityManager em = emf.createEntityManager();

        EntityB entityB = new EntityB();
        entityB.setMyStr2("a test string in EntityB");

        ClassA a = new ClassA();
        a.setMyStr("a test string in ClassA");
        a.setEntityBRef(entityB);

        EntityA entityA = new EntityA();
        entityA.setClassARef(a);

        System.out.println(entityA);

        em.getTransaction().begin();
        em.persist(entityA);
        em.persist(entityB);
        em.getTransaction().commit();
        em.close();
    }

    private static void runNativeQueries(EntityManagerFactory emf) {
        System.out.println("-- native queries --");
        EntityManager em = emf.createEntityManager();
        ExampleMain.nativeQuery(em, "Select * from EntityA");
        ExampleMain.nativeQuery(em, "Select * from EntityB");
    }

    private static void loadEntity(EntityManagerFactory emf) {
        System.out.println("-- Loading EntityA --");
        EntityManager em = emf.createEntityManager();
        List<EntityA> entityAList = em.createQuery("Select t from EntityA t")
                                      .getResultList();
        entityAList.forEach(System.out::println);

        System.out.println("-- Loading EntityB --");
        List<EntityB> entityBList = em.createQuery("Select t from EntityB t")
                                      .getResultList();
        entityBList.forEach(System.out::println);
        em.close();
    }
}